//------------------------------------------------------------------------------
//The contents of this file are subject to the Mozilla Public License
//Version 1.1 (the "License"); you may not use this file except in compliance
//with the License. You may obtain a copy of the License at
//http://www.mozilla.org/MPL/ Software distributed under the License is
//distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
//or implied. See the License for the specific language governing rights and
//limitations under the License.
//
//The Original Code is KeyedLst.pas.
//
//The Initial Developer of the Original Code is Alex Shovkoplyas, VE3NEA.
//Portions created by Alex Shovkoplyas are
//Copyright (C) 2008 Alex Shovkoplyas. All Rights Reserved.
//------------------------------------------------------------------------------
unit KeyedLst;

interface

uses
  Windows, SysUtils, Classes, Contnrs;


type
  TKeyedItem = class
  public
    Key: DWord;
  end;

  TKeyedList = class (TObjectList)
  public
    function Find(AKey: DWord; var Idx: integer): boolean;
    function FindKey(AKey: DWord): Integer;
    procedure Add(Item: TKeyedItem);
  end;



implementation

{ TKeyedList }

procedure TKeyedList.Add(Item: TKeyedItem);
var
  Idx: integer;
begin
  Idx := FindKey(Item.Key);
  Insert(Idx, Item);
end;


function TKeyedList.Find(AKey: DWord; var Idx: integer): boolean;
begin
  Idx := FindKey(AKey);
  Result := (Idx < Count) and (TKeyedItem(Items[Idx]).Key = AKey);
end;


function TKeyedList.FindKey(AKey: DWord): Integer;
var
  L, H, i: Integer;
begin
  L := 0;
  H := Count - 1;

  while L <= H do
    begin
    i := (L + H) shr 1;
    if TKeyedItem(Items[I]).Key < AKey then L := i + 1 else H := i - 1;
    end;

  Result := L;
end;



end.

