/* disasm.h   header file for disasm.c
 *
 * The Netwide Assembler is copyright (C) 1996 Simon Tatham and
 * Julian Hall. All rights reserved. The software is
 * redistributable under the license given in the file "LICENSE"
 * distributed in the NASM archive.
 */

/*
Modified by Alex Shovkoplyas 2009-02-18
  - declaration of InstrInfo added
  - the InstrInfo* Info parameter added to the declaration of disasm()
*/


#ifndef NASM_DISASM_H
#define NASM_DISASM_H

#define INSN_MAX 32             /* one instruction can't be longer than this */



#include "nasm.h"
#include "insns.h"

//A.S.
typedef struct {
  struct itemplate *Templ;
  struct insn Instr;
} InstrInfo;




//int32_t disasm(uint8_t *data, char *output, int outbufsize, int segsize,
//            int32_t offset, int autosync, uint32_t prefer);

//A/S/
int32_t disasm(uint8_t *data, char *output, int outbufsize, int segsize,
            int32_t offset, int autosync, uint32_t prefer, InstrInfo* Info);


int32_t eatbyte(uint8_t *data, char *output, int outbufsize);


#endif