//------------------------------------------------------------------------------
//The contents of this file are subject to the Mozilla Public License
//Version 1.1 (the "License"); you may not use this file except in compliance
//with the License. You may obtain a copy of the License at
//http://www.mozilla.org/MPL/ Software distributed under the License is
//distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
//or implied. See the License for the specific language governing rights and
//limitations under the License.
//
//The Original Code is ProgrDlg.pas.
//
//The Initial Developer of the Original Code is Alex Shovkoplyas, VE3NEA.
//Portions created by Alex Shovkoplyas are
//Copyright (C) 2008 Alex Shovkoplyas. All Rights Reserved.
//------------------------------------------------------------------------------
unit ProgrDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, DbgSrc;

type
  TDlProgressDialog = class(TForm)
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    Image1: TImage;
    Button1: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  public
    procedure ShowProgress(AText: string; APercent: Single);
  end;

var
  DlProgressDialog: TDlProgressDialog;



implementation

uses Main;

{$R *.DFM}

{ TDlProgressDialog }

procedure TDlProgressDialog.ShowProgress(AText: string; APercent: Single);
begin
  if not Timer1.Enabled then Timer1.Enabled := true;

  Label1.Caption := AText;
  Label1.Update;
  ProgressBar1.Position := Round(APercent * 100);
end;


procedure TDlProgressDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Timer1.Enabled := false;
  Label1.Caption := '';
end;


procedure TDlProgressDialog.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  Show;
end;


procedure TDlProgressDialog.Button1Click(Sender: TObject);
begin
  Label1.Caption := 'Aborting...';
  Label1.Update;

  SetSymbolsPath(MainForm.Settings.SymbolsPath, false);
end;



end.

