//------------------------------------------------------------------------------
//The contents of this file are subject to the Mozilla Public License
//Version 1.1 (the "License"); you may not use this file except in compliance
//with the License. You may obtain a copy of the License at
//http://www.mozilla.org/MPL/ Software distributed under the License is
//distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
//or implied. See the License for the specific language governing rights and
//limitations under the License.
//
//The Original Code is ThrLst.pas.
//
//The Initial Developer of the Original Code is Alex Shovkoplyas, VE3NEA.
//Portions created by Alex Shovkoplyas are
//Copyright (C) 2008 Alex Shovkoplyas. All Rights Reserved.
//------------------------------------------------------------------------------
unit ThrLst;

interface

uses
  Windows, SysUtils, Classes, KeyedLst;


type
  TThreadItem = class(TKeyedItem)
  public
    Name: string;
    Main: boolean;
    property Id: DWord read Key write Key;
  end;


  TThreadList = class(TKeyedList)
  public
    procedure AddThread(ThreadId: DWord; AMain: boolean = false);
    procedure SetThreadName(ThreadId: DWord; AName: string);
  end;


  
implementation

{ TThreadList }

procedure TThreadList.AddThread(ThreadId: DWord; AMain: boolean = false);
var
  Idx: integer;
  Item: TThreadItem;
begin
  Idx := FindKey(ThreadId);
  if (Idx < Count) and (TThreadItem(Items[Idx]).Id = ThreadId) then Exit;

  Item := TThreadItem.Create;
  Item.Id := ThreadId;
  Item.Main := AMain;

  if AMain
    then Item.Name := 'Main Thread'
    else Item.Name := Format('Thread #%d', [Item.Id]);
    
  Add(Item);
end;


procedure TThreadList.SetThreadName(ThreadId: DWord; AName: string);
var
  Idx: integer;
  Item: TThreadItem;
begin
  Idx := FindKey(ThreadId);
  if (Idx < Count) and (TThreadItem(Items[Idx]).Id = ThreadId)
    then
      TThreadItem(Items[Idx]).Name := AName
    else
      begin
      Item := TThreadItem.Create;
      Item.Id := ThreadId;
      Item.Name := AName;
      Add(Item);
      end;
end;



end.

